## dsda-doom 0.29.4+dfsg

=== prboom2/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.17...4.0)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake")

# Setup dependencies options before `project()` so vcpkg features can be used
include(DsdaDepsSetup)

project("dsda-doom" VERSION 0.29.4)

set(dsda_is_top_project FALSE)
if(CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
    set(dsda_is_top_project TRUE)
endif()

if(dsda_is_top_project)
    include(DsdaSanitiser)
endif()

include(DsdaHelpers)
if(dsda_is_top_project)
    dsda_set_default_build_config(RelWithDebInfo)
endif()

if(VCPKG_TOOLCHAIN)
    set(ENV{PKG_CONFIG_PATH} "${VCPKG_INSTALLED_DIR}/${VCPKG_TARGET_TRIPLET}/lib/pkgconfig")
endif()

set(PROJECT_TARNAME "dsda-doom")
set(WAD_DATA "dsda-doom.wad")
set(PROJECT_STRING "${PROJECT_NAME} ${PROJECT_VERSION}")

include(DsdaOptions)
include(DsdaTargetFeatures)
include(DsdaDependencies)
include(DsdaConfigHeader)

set(DSDA_OUTPUT_PATH ${CMAKE_BINARY_DIR})

set(WAD_DATA_PATH "${DSDA_OUTPUT_PATH}/${WAD_DATA}")

set(DSDA_BUILD_PWAD_WITH_EXTERNAL_PROJECT ${CMAKE_CROSSCOMPILING})
if(CMAKE_GENERATOR MATCHES "Visual Studio")
    set(DSDA_BUILD_PWAD_WITH_EXTERNAL_PROJECT TRUE)
    set(DSDA_EXTERNAL_PROJECT_VS_ARGS
        "CMAKE_GENERATOR" "${CMAKE_GENERATOR}"
        "CMAKE_GENERATOR_PLATFORM" "${CMAKE_VS_PLATFORM_NAME_DEFAULT}"
    )
endif()

if(DSDA_BUILD_PWAD_WITH_EXTERNAL_PROJECT)
    set(DSDA_HOST_TOOLCHAIN ""
        CACHE FILEPATH "Toolchain file to build host tools with"
    )
    include(ExternalProject)
    ExternalProject_Add(dsda-doom-wad
        SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/data"
        ${DSDA_EXTERNAL_PROJECT_VS_ARGS}
        CMAKE_CACHE_ARGS
            "-DCMAKE_BUILD_TYPE:STRING=${CMAKE_BUILD_TYPE}"
            "-DWAD_DATA_PATH:FILEPATH=${WAD_DATA_PATH}"
            "-DCMAKE_TOOLCHAIN_FILE:FILEPATH=${DSDA_HOST_TOOLCHAIN}"
        BUILD_ALWAYS TRUE
        BUILD_BYPRODUCTS "${WAD_DATA_PATH}"
        INSTALL_COMMAND ""
    )
else()
    add_subdirectory(data)
endif()

add_subdirectory(src)
add_subdirectory(ICONS)

install(FILES
    "${WAD_DATA_PATH}"
    DESTINATION "${DSDAPWADDIR}"
)

install(FILES
    "COPYING"
    DESTINATION "${DSDA_INSTALL_COPYRIGHT_DIR}"
)

if(ENABLE_PACKAGING)
    add_subdirectory(packaging)
endif()

=== prboom2/ICONS/CMakeLists.txt ===
if(UNIX AND NOT APPLE)
    install(FILES dsda-doom.desktop DESTINATION share/applications)
    install(FILES dsda-doom.svg DESTINATION share/icons/hicolor/scalable/apps)
endif()

=== prboom2/data/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8...4.0)
project(dsda-doom-wad
    LANGUAGES C
)

if(CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
    list(APPEND
        CMAKE_MODULE_PATH
        "${CMAKE_CURRENT_LIST_DIR}/../cmake"
    )
endif()

# PrBoom-Plus WAD creation tool

add_executable(dsda_rdatawad
    rd_main.c
    rd_util.c
    rd_util.h
    rd_output.c
    rd_output.h
    rd_sound.c
    rd_sound.h
    rd_palette.c
    rd_palette.h
    rd_graphic.c
    rd_graphic.h
)

target_compile_features(dsda_rdatawad
    PRIVATE c_std_99
)
set_target_properties(dsda_rdatawad
    PROPERTIES
    OUTPUT_NAME rdatawad
)

include(DsdaTargetFeatures)
dsda_target_set_warnings(dsda_rdatawad)
dsda_target_silence_deprecation(dsda_rdatawad)

include(CheckBigEndian)
check_big_endian(RD_IS_BIG_ENDIAN)

target_compile_definitions(dsda_rdatawad
    PRIVATE
    "RD_IS_BIG_ENDIAN=${RD_IS_BIG_ENDIAN}"
)

# PrBoom-Plus internal WAD

set(PALETTE
    palette.rgb
)

set(LUMPS
    lumps/switches.lmp
    lumps/animated.lmp
    lumps/sndcurve.lmp
    lumps/soundfont/sndfont.lmp
    lumps/dsdacr.lmp
    lumps/dsdahud.lmp
    lumps/dsdatc.lmp
)

set(COLORMAPS
    lumps/watermap.lmp
)

set(TABLES
    lumps/sinetabl.lmp
    lumps/tangtabl.lmp
    lumps/tantoang.lmp
    lumps/gammatbl.lmp
    lumps/chexdeh.lmp
    lumps/bfgbex.lmp
    lumps/nervebex.lmp
    lumps/glshadow.lmp
    lumps/gls_main.lmp
    lumps/gls_fuzz.lmp
    lumps/gls_v.lmp
    lumps/m_ammo.lmp
    lumps/m_armour.lmp
    lumps/m_arrow.lmp
    lumps/m_health.lmp
    lumps/m_key.lmp
    lumps/m_normal.lmp
    lumps/m_shadow.lmp
    lumps/m_power.lmp
    lumps/m_weap.lmp
    lumps/m_mark.lmp
)

set(SOUNDS
    sounds/dsdgsit.wav
    sounds/dsdgatk.wav
    sounds/dsdgact.wav
    sounds/dsdgdth.wav
    sounds/dsdgpain.wav
    sounds/dssecret.wav
)

set(GRAPHICS
    graphics/dig033.ppm
    graphics/dig034.ppm
    graphics/dig035.ppm
    graphics/dig036.ppm
    graphics/dig037.ppm
    graphics/dig038.ppm
    graphics/dig039.ppm
    graphics/dig040.ppm
    graphics/dig041.ppm
    graphics/dig042.ppm
    graphics/dig043.ppm
    graphics/dig044.ppm
    graphics/dig045.ppm
    graphics/dig046.ppm
    graphics/dig047.ppm
    graphics/dig048.ppm
    graphics/dig049.ppm
    graphics/dig050.ppm
    graphics/dig051.ppm
    graphics/dig052.ppm
    graphics/dig053.ppm
    graphics/dig054.ppm
    graphics/dig055.ppm
    graphics/dig056.ppm
    graphics/dig057.ppm
    graphics/dig058.ppm
    graphics/dig059.ppm
    graphics/dig060.ppm
    graphics/dig061.ppm
    graphics/dig062.ppm
    graphics/dig063.ppm
    graphics/dig064.ppm
    graphics/dig065.ppm
    graphics/dig066.ppm
    graphics/dig067.ppm
    graphics/dig068.ppm
    graphics/dig069.ppm
    graphics/dig070.ppm
    graphics/dig071.ppm
    graphics/dig072.ppm
    graphics/dig073.ppm
    graphics/dig074.ppm
    graphics/dig075.ppm
    graphics/dig076.ppm
    graphics/dig077.ppm
    graphics/dig078.ppm
    graphics/dig079.ppm
    graphics/dig080.ppm
    graphics/dig081.ppm
    graphics/dig082.ppm
    graphics/dig083.ppm
    graphics/dig084.ppm
    graphics/dig085.ppm
    graphics/dig086.ppm
    graphics/dig087.ppm
    graphics/dig088.ppm
    graphics/dig089.ppm
    graphics/dig090.ppm
    graphics/dig091.ppm
    graphics/dig092.ppm
    graphics/dig093.ppm
    graphics/dig094.ppm
    graphics/dig095.ppm
    graphics/dig096.ppm
    graphics/dig097.ppm
    graphics/dig098.ppm
    graphics/dig099.ppm
    graphics/dig100.ppm
    graphics/dig101.ppm
    graphics/dig102.ppm
    graphics/dig103.ppm
    graphics/dig104.ppm
    graphics/dig105.ppm
    graphics/dig106.ppm
    graphics/dig107.ppm
    graphics/dig108.ppm
    graphics/dig109.ppm
    graphics/dig110.ppm
    graphics/dig111.ppm
    graphics/dig112.ppm
    graphics/dig113.ppm
    graphics/dig114.ppm
    graphics/dig115.ppm
    graphics/dig116.ppm
    graphics/dig117.ppm
    graphics/dig118.ppm
    graphics/dig119.ppm
    graphics/dig120.ppm
    graphics/dig121.ppm
    graphics/dig122.ppm
    graphics/dig123.ppm
    graphics/dig124.ppm
    graphics/dig125.ppm
    graphics/dig126.ppm
    graphics/fonta06.ppm
    graphics/fonta28.ppm
    graphics/fonta30.ppm
    graphics/boxul.ppm
    graphics/boxuc.ppm
    graphics/boxur.ppm
    graphics/boxcl.ppm
    graphics/boxcc.ppm
    graphics/boxcr.ppm
    graphics/boxll.ppm
    graphics/boxlc.ppm
    graphics/boxlr.ppm
    graphics/stkeys6.ppm
    graphics/stkeys7.ppm
    graphics/stkeys8.ppm
    graphics/stcfn096.ppm
    graphics/m_butt1.ppm
    graphics/m_butt2.ppm
    graphics/m_colors.ppm
    graphics/m_palno.ppm
    graphics/m_palsel.ppm
    graphics/m_vbox.ppm
    graphics/cross1.ppm
    graphics/cross2.ppm
    graphics/cross3.ppm
    graphics/cross4.ppm
    graphics/cross5.ppm
    graphics/cross6.ppm
    graphics/cross7.ppm
)

set(FLATS
    flats/-n0_tex-.ppm
)

set(SPRITES
    sprites/tnt1a0.ppm
)
set(SPRITEP "0,0,sprites/tnt1a0.ppm")

set(SPRITES
    ${SPRITES}
    sprites/dogsa1.ppm
    sprites/dogsa2.ppm
    sprites/dogsa3.ppm
    sprites/dogsa4.ppm
    sprites/dogsa5.ppm
    sprites/dogsa6.ppm
    sprites/dogsa7.ppm
    sprites/dogsa8.ppm
    sprites/dogsb1.ppm
    sprites/dogsb2.ppm
    sprites/dogsb3.ppm
    sprites/dogsb4.ppm
    sprites/dogsb5.ppm
    sprites/dogsb6.ppm
    sprites/dogsb7.ppm
    sprites/dogsb8.ppm
    sprites/dogsc1.ppm
    sprites/dogsc2.ppm
    sprites/dogsc3.ppm
    sprites/dogsc4.ppm
    sprites/dogsc5.ppm
    sprites/dogsc6.ppm
    sprites/dogsc7.ppm
    sprites/dogsc8.ppm
    sprites/dogsd1.ppm
    sprites/dogsd2.ppm
    sprites/dogsd3.ppm
    sprites/dogsd4.ppm
    sprites/dogsd5.ppm
    sprites/dogsd6.ppm
    sprites/dogsd7.ppm
    sprites/dogsd8.ppm
    sprites/dogse1.ppm
    sprites/dogse2.ppm
    sprites/dogse3.ppm
    sprites/dogse4.ppm
    sprites/dogse5.ppm
    sprites/dogse6.ppm
    sprites/dogse7.ppm
    sprites/dogse8.ppm
    sprites/dogsf1.ppm
    sprites/dogsf2.ppm
    sprites/dogsf3.ppm
    sprites/dogsf4.ppm
    sprites/dogsf5.ppm
    sprites/dogsf6.ppm
    sprites/dogsf7.ppm
    sprites/dogsf8.ppm
    sprites/dogsg1.ppm
    sprites/dogsg2.ppm
    sprites/dogsg3.ppm
    sprites/dogsg4.ppm
    sprites/dogsg5.ppm
    sprites/dogsg6.ppm
    sprites/dogsg7.ppm
    sprites/dogsg8.ppm
    sprites/dogsh1.ppm
    sprites/dogsh2.ppm
    sprites/dogsh3.ppm
    sprites/dogsh4.ppm
    sprites/dogsh5.ppm
    sprites/dogsh6.ppm
    sprites/dogsh7.ppm
    sprites/dogsh8.ppm
    sprites/dogsi0.ppm
    sprites/dogsj0.ppm
    sprites/dogsk0.ppm
    sprites/dogsl0.ppm
    sprites/dogsm0.ppm
    sprites/dogsn0.ppm
)
set(SPRITEP
    ${SPRITEP}
    "33,66,sprites/dogsa1.ppm"
    "33,66,sprites/dogsa2.ppm"
    "33,66,sprites/dogsa3.ppm"
    "33,66,sprites/dogsa4.ppm"
    "33,66,sprites/dogsa5.ppm"
    "33,66,sprites/dogsa6.ppm"
    "33,66,sprites/dogsa7.ppm"
    "33,66,sprites/dogsa8.ppm"
    "33,66,sprites/dogsb1.ppm"
    "33,66,sprites/dogsb2.ppm"
    "33,66,sprites/dogsb3.ppm"
    "33,66,sprites/dogsb4.ppm"
    "33,66,sprites/dogsb5.ppm"
    "33,66,sprites/dogsb6.ppm"
    "33,66,sprites/dogsb7.ppm"
    "33,66,sprites/dogsb8.ppm"
    "33,66,sprites/dogsc1.ppm"
    "33,66,sprites/dogsc2.ppm"
    "33,66,sprites/dogsc3.ppm"
    "33,66,sprites/dogsc4.ppm"
    "33,66,sprites/dogsc5.ppm"
    "33,66,sprites/dogsc6.ppm"
    "33,66,sprites/dogsc7.ppm"
    "33,66,sprites/dogsc8.ppm"
    "33,66,sprites/dogsd1.ppm"
    "33,66,sprites/dogsd2.ppm"
    "33,66,sprites/dogsd3.ppm"
    "33,66,sprites/dogsd4.ppm"
    "33,66,sprites/dogsd5.ppm"
    "33,66,sprites/dogsd6.ppm"
    "33,66,sprites/dogsd7.ppm"
    "33,66,sprites/dogsd8.ppm"
    "33,66,sprites/dogse1.ppm"
    "33,66,sprites/dogse2.ppm"
    "33,66,sprites/dogse3.ppm"
    "33,66,sprites/dogse4.ppm"
    "33,66,sprites/dogse5.ppm"
    "33,66,sprites/dogse6.ppm"
    "33,66,sprites/dogse7.ppm"
    "33,66,sprites/dogse8.ppm"
    "33,66,sprites/dogsf1.ppm"
    "33,66,sprites/dogsf2.ppm"
    "33,66,sprites/dogsf3.ppm"
    "33,66,sprites/dogsf4.ppm"
    "33,66,sprites/dogsf5.ppm"
    "33,66,sprites/dogsf6.ppm"
    "33,66,sprites/dogsf7.ppm"
    "33,66,sprites/dogsf8.ppm"
    "33,66,sprites/dogsg1.ppm"
    "33,66,sprites/dogsg2.ppm"
    "33,66,sprites/dogsg3.ppm"
    "33,66,sprites/dogsg4.ppm"
    "33,66,sprites/dogsg5.ppm"
    "33,66,sprites/dogsg6.ppm"
    "33,66,sprites/dogsg7.ppm"
    "33,66,sprites/dogsg8.ppm"
    "33,66,sprites/dogsh1.ppm"
    "33,66,sprites/dogsh2.ppm"
    "33,66,sprites/dogsh3.ppm"
    "33,66,sprites/dogsh4.ppm"
    "33,66,sprites/dogsh5.ppm"
    "33,66,sprites/dogsh6.ppm"
    "33,66,sprites/dogsh7.ppm"
    "33,66,sprites/dogsh8.ppm"
    "33,67,sprites/dogsi0.ppm"
    "33,67,sprites/dogsj0.ppm"
    "33,67,sprites/dogsk0.ppm"
    "33,67,sprites/dogsl0.ppm"
    "33,68,sprites/dogsm0.ppm"
    "33,69,sprites/dogsn0.ppm"
)

set(SPRITES
    ${SPRITES}
    sprites/pls1a0.ppm
    sprites/pls1b0.ppm
    sprites/pls1c0.ppm
    sprites/pls1d0.ppm
    sprites/pls1e0.ppm
    sprites/pls1f0.ppm
    sprites/pls1g0.ppm
    sprites/pls2a0.ppm
    sprites/pls2b0.ppm
    sprites/pls2c0.ppm
    sprites/pls2d0.ppm
    sprites/pls2e0.ppm
)
set(SPRITEP
    ${SPRITEP}
    "9,11,sprites/pls1a0.ppm"
    "8,11,sprites/pls1b0.ppm"
    "9,11,sprites/pls1c0.ppm"
    "8,11,sprites/pls1d0.ppm"
    "16,27,sprites/pls1e0.ppm"
    "16,27,sprites/pls1f0.ppm"
    "18,27,sprites/pls1g0.ppm"
    "9,11,sprites/pls2a0.ppm"
    "8,13,sprites/pls2b0.ppm"
    "11,18,sprites/pls2c0.ppm"
    "16,27,sprites/pls2d0.ppm"
    "18,27,sprites/pls2e0.ppm"
)

set(WAD_SRC
    ${PALETTE}
    ${LUMPS}
    ${COLORMAPS}
    ${TABLES}
    ${SOUNDS}
    ${GRAPHICS}
    ${FLATS}
    ${SPRITES}
)

set(WAD_CMDLINE
    -palette ${PALETTE}
    -lumps ${LUMPS}
    -marker C_START -lumps ${COLORMAPS} -marker C_END
    -marker B_START -lumps ${TABLES} -marker B_END
    -sounds ${SOUNDS}
    -graphics ${GRAPHICS}
    -marker FF_START -flats ${FLATS} -marker FF_END
    -marker SS_START -sprites ${SPRITEP} -marker SS_END
)

add_custom_command(
    OUTPUT ${WAD_DATA_PATH}
    COMMAND dsda_rdatawad -I "${CMAKE_CURRENT_SOURCE_DIR}" ${WAD_CMDLINE} -o "${WAD_DATA_PATH}"
    DEPENDS dsda_rdatawad ${WAD_SRC}
    VERBATIM
)

add_custom_target(dsda-doom-wad 
    ALL
    DEPENDS ${WAD_DATA_PATH}
)

=== prboom2/packaging/CMakeLists.txt ===
set(CPACK_PACKAGE_NAME ${PROJECT_NAME})
set(CPACK_PACKAGE_VENDOR "DSDA-Doom maintainers")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "This is a successor of prboom+ with extra tooling for demo recording and playback, with a focus on speedrunning and quality of life.")
set(CPACK_PACKAGE_INSTALL_DIRECTORY ${CPACK_PACKAGE_NAME})
set(CPACK_PACKAGE_VERSION_MAJOR ${PROJECT_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${PROJECT_VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${PROJECT_VERSION_PATCH})
set(CPACK_VERBATIM_VARIABLES YES)
set(CPACK_RESOURCE_FILE_LICENSE ${PROJECT_SOURCE_DIR}/COPYING)

if(WIN32)
  set(CPACK_GENERATOR ZIP)
elseif(LINUX OR APPLE)
  set(CPACK_GENERATOR External TXZ)
  set(CPACK_EXTERNAL_ENABLE_STAGING TRUE)
  set(CPACK_EXTERNAL_PACKAGE_SCRIPT "${CMAKE_CURRENT_SOURCE_DIR}/${CMAKE_SYSTEM_NAME}Generator.cmake")
  set(CPACK_PACKAGING_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}")
  set(CPACK_SYSTEM_PROCESSOR ${CMAKE_SYSTEM_PROCESSOR})
  set(CPACK_BIN_DIR "${DSDA_INSTALL_BINDIR}")
  set(CPACK_PWAD_DIR "${DSDAPWADDIR}")
  set(CPACK_LICENSE_DIR "${DSDA_INSTALL_COPYRIGHT_DIR}")
endif()

set(target_arch ${CMAKE_SYSTEM_PROCESSOR})
if(CMAKE_GENERATOR MATCHES "Visual Studio")
  string(TOLOWER "${CMAKE_VS_PLATFORM_NAME}" target_arch)
  string(REPLACE "win32" "x86" target_arch "${target_arch}")
elseif(CMAKE_OSX_ARCHITECTURES)
  list(JOIN CMAKE_OSX_ARCHITECTURES "-" target_arch)
endif()

string(TOLOWER "${CMAKE_SYSTEM_NAME}" platform_name)
string(REPLACE "windows" "win" platform_name "${platform_name}")
string(REPLACE "darwin" "mac" platform_name "${platform_name}")

set(CPACK_PACKAGE_FILE_NAME "${CPACK_PACKAGE_NAME}-${PROJECT_VERSION}-${platform_name}-${target_arch}")

include(CPack)

=== prboom2/src/CMakeLists.txt ===
# PrBoom main executable

set(COMMON_SRC
    am_map.c
    am_map.h
    doomdata.h
    doomdef.c
    doomdef.h
    doomstat.c
    doomstat.h
    doomtype.h
    dsda.c
    dsda.h
    dsda/aim.c
    dsda/aim.h
    dsda/ambient.cpp
    dsda/ambient.h
    dsda/analysis.c
    dsda/analysis.h
    dsda/args.c
    dsda/args.h
    dsda/brute_force.c
    dsda/brute_force.h
    dsda/build.c
    dsda/build.h
    dsda/compatibility.c
    dsda/compatibility.h
    dsda/configuration.c
    dsda/configuration.h
    dsda/console.c
    dsda/console.h
    dsda/cr_table.c
    dsda/cr_table.h
    dsda/data_organizer.c
    dsda/data_organizer.h
    dsda/death.c
    dsda/death.h
    dsda/deh_hash.c
    dsda/deh_hash.h
    dsda/demo.c
    dsda/demo.h
    dsda/destructible.c
    dsda/destructible.h
    dsda/endoom.c
    dsda/endoom.h
    dsda/episode.c
    dsda/episode.h
    dsda/excmd.c
    dsda/excmd.h
    dsda/exdemo.c
    dsda/exdemo.h
    dsda/exhud.c
    dsda/exhud.h
    dsda/features.c
    dsda/features.h
    dsda/font.c
    dsda/font.h
    dsda/game_controller.c
    dsda/game_controller.h
    dsda/gameinfo.cpp
    dsda/gameinfo.h
    dsda/ghost.c
    dsda/ghost.h
    dsda/gl/render_scale.c
    dsda/gl/render_scale.h
    dsda/global.c
    dsda/global.h
    dsda/hud_components.h
    dsda/hud_components/ammo_text.c
    dsda/hud_components/ammo_text.h
    dsda/hud_components/armor_text.c
    dsda/hud_components/armor_text.h
    dsda/hud_components/attempts.c
    dsda/hud_components/attempts.h
    dsda/hud_components/base.c
    dsda/hud_components/base.h
    dsda/hud_components/big_ammo.c
    dsda/hud_components/big_ammo.h
    dsda/hud_components/big_armor.c
    dsda/hud_components/big_armor.h
    dsda/hud_components/big_armor_text.c
    dsda/hud_components/big_armor_text.h
    dsda/hud_components/big_artifact.c
    dsda/hud_components/big_artifact.h
    dsda/hud_components/big_health.c
    dsda/hud_components/big_health.h
    dsda/hud_components/big_health_text.c
    dsda/hud_components/big_health_text.h
    dsda/hud_components/color_test.c
    dsda/hud_components/color_test.h
    dsda/hud_components/command_display.c
    dsda/hud_components/command_display.h
    dsda/hud_components/composite_time.c
    dsda/hud_components/composite_time.h
    dsda/hud_components/coordinate_display.c
    dsda/hud_components/coordinate_display.h
    dsda/hud_components/event_split.c
    dsda/hud_components/event_split.h
    dsda/hud_components/fps.c
    dsda/hud_components/fps.h
    dsda/hud_components/free_text.c
    dsda/hud_components/free_text.h
    dsda/hud_components/health_text.c
    dsda/hud_components/health_text.h
    dsda/hud_components/keys.c
    dsda/hud_components/keys.h
    dsda/hud_components/level_splits.c
    dsda/hud_components/level_splits.h
    dsda/hud_components/line_display.c
    dsda/hud_components/line_display.h
    dsda/hud_components/line_distance_tracker.c
    dsda/hud_components/line_distance_tracker.h
    dsda/hud_components/line_tracker.c
    dsda/hud_components/line_tracker.h
    dsda/hud_components/local_time.c
    dsda/hud_components/local_time.h
    dsda/hud_components/map_coordinates.c
    dsda/hud_components/map_coordinates.h
    dsda/hud_components/map_time.c
    dsda/hud_components/map_time.h
    dsda/hud_components/map_title.c
    dsda/hud_components/map_title.h
    dsda/hud_components/map_totals.c
    dsda/hud_components/map_totals.h
    dsda/hud_components/message.c
    dsda/hud_components/message.h
    dsda/hud_components/minimap.c
    dsda/hud_components/minimap.h
    dsda/hud_components/mobj_tracker.c
    dsda/hud_components/mobj_tracker.h
    dsda/hud_components/null.c
    dsda/hud_components/null.h
    dsda/hud_components/player_tracker.c
    dsda/hud_components/player_tracker.h
    dsda/hud_components/ready_ammo_text.c
    dsda/hud_components/ready_ammo_text.h
    dsda/hud_components/render_stats.c
    dsda/hud_components/render_stats.h
    dsda/hud_components/secret_message.c
    dsda/hud_components/secret_message.h
    dsda/hud_components/sector_tracker.c
    dsda/hud_components/sector_tracker.h
    dsda/hud_components/speed_text.c
    dsda/hud_components/speed_text.h
    dsda/hud_components/stat_totals.c
    dsda/hud_components/stat_totals.h
    dsda/hud_components/tracker.c
    dsda/hud_components/tracker.h
    dsda/hud_components/weapon_text.c
    dsda/hud_components/weapon_text.h
    dsda/id_list.c
    dsda/id_list.h
    dsda/input.c
    dsda/input.h
    dsda/key_frame.c
    dsda/key_frame.h
    dsda/line_special.h
    dsda/map_format.c
    dsda/map_format.h
    dsda/mapinfo.c
    dsda/mapinfo.h
    dsda/mapinfo/doom.c
    dsda/mapinfo/doom.h
    dsda/mapinfo/doom/parser.cpp
    dsda/mapinfo/doom/parser.h
    dsda/mapinfo/hexen.c
    dsda/mapinfo/hexen.h
    dsda/mapinfo/legacy.c
    dsda/mapinfo/legacy.h
    dsda/mapinfo/u.c
    dsda/mapinfo/u.h
    dsda/memory.c
    dsda/memory.h
    dsda/messenger.c
    dsda/messenger.h
    dsda/mobjinfo.c
    dsda/mobjinfo.h
    dsda/mouse.c
    dsda/mouse.h
    dsda/msecnode.c
    dsda/msecnode.h
    dsda/music.c
    dsda/music.h
    dsda/name.c
    dsda/name.h
    dsda/options.c
    dsda/options.h
    dsda/palette.c
    dsda/palette.h
    dsda/pause.c
    dsda/pause.h
    dsda/pclass.c
    dsda/pclass.h
    dsda/playback.c
    dsda/playback.h
    dsda/preferences.c
    dsda/preferences.h
    dsda/quake.c
    dsda/render_stats.c
    dsda/render_stats.h
    dsda/save.c
    dsda/save.h
    dsda/scroll.c
    dsda/scroll.h
    dsda/settings.c
    dsda/settings.h
    dsda/sfx.c
    dsda/sfx.h
    dsda/signal_context.h
    dsda/skill_info.c
    dsda/skill_info.h
    dsda/skip.c
    dsda/skip.h
    dsda/sndinfo.c
    dsda/sndinfo.h
    dsda/spawn_number.c
    dsda/spawn_number.h
    dsda/split_tracker.c
    dsda/split_tracker.h
    dsda/sprite.c
    dsda/sprite.h
    dsda/state.c
    dsda/state.h
    dsda/stretch.c
    dsda/stretch.h
    dsda/text_color.c
    dsda/text_color.h
    dsda/text_file.c
    dsda/text_file.h
    dsda/thing_id.c
    dsda/thing_id.h
    dsda/time.c
    dsda/time.h
    dsda/tracker.c
    dsda/tracker.h
    dsda/tranmap.c
    dsda/tranmap.h
    dsda/udmf.cpp
    dsda/udmf.h
    dsda/utility.c
    dsda/utility.h
    dsda/utility/string_view.c
    dsda/utility/string_view.h
    dsda/wad_stats.c
    dsda/wad_stats.h
    dsda/zipfile.c
    dsda/zipfile.h
    dstrings.c
    dstrings.h
    d_deh.c
    d_deh.h
    d_englsh.h
    d_event.h
    d_items.c
    d_items.h
    d_main.c
    d_main.h
    d_net.h
    d_player.h
    d_think.h
    d_ticcmd.h
    e6y.c
    e6y.h
    f_finale.c
    f_finale.h
    f_wipe.c
    f_wipe.h
    g_game.c
    g_game.h
    g_overflow.c
    g_overflow.h
    heretic/d_main.c
    heretic/def.h
    heretic/dstrings.h
    heretic/f_finale.h
    heretic/f_finale.c
    heretic/info.c
    heretic/in_lude.c
    heretic/in_lude.h
    heretic/level_names.c
    heretic/mn_menu.c
    heretic/mn_menu.h
    heretic/p_action.h
    heretic/sb_bar.c
    heretic/sb_bar.h
    heretic/sounds.c
    hexen/a_action.c
    hexen/a_action.h
    hexen/info.c
    hexen/f_finale.c
    hexen/f_finale.h
    hexen/h2_main.c
    hexen/in_lude.c
    hexen/in_lude.h
    hexen/p_acs.c
    hexen/p_acs.h
    hexen/p_anim.c
    hexen/p_anim.h
    hexen/p_things.c
    hexen/p_things.h
    hexen/po_man.c
    hexen/po_man.h
    hexen/sn_sonix.c
    hexen/sn_sonix.h
    hexen/sounds.c
    hexen/sv_save.c
    hexen/sv_save.h
    hu_lib.c
    hu_lib.h
    hu_stuff.c
    hu_stuff.h
    info.c
    info.h
    i_capture.c
    i_capture.h
    i_glob.c
    i_glob.h
    i_main.h
    i_sound.h
    i_system.h
    i_video.h
    lprintf.c
    lprintf.h
    md5.c
    md5.h
    m_argv.c
    m_argv.h
    m_bbox.c
    m_bbox.h
    m_cheat.c
    m_cheat.h
    m_file.c
    m_file.h
    m_fixed.h
    m_menu.c
    m_menu.h
    m_misc.c
    m_misc.h
    m_random.c
    m_random.h
    m_swap.h
    p_ceilng.c
    p_doors.c
    p_enemy.c
    p_enemy.h
    p_floor.c
    p_genlin.c
    p_inter.c
    p_inter.h
    p_lights.c
    p_map.c
    p_map.h
    p_maputl.c
    p_maputl.h
    p_mobj.c
    p_mobj.h
    p_plats.c
    p_pspr.c
    p_pspr.h
    p_saveg.c
    p_saveg.h
    p_setup.c
    p_setup.h
    p_sight.c
    p_spec.c
    p_spec.h
    p_switch.c
    p_telept.c
    p_tick.c
    p_tick.h
    p_user.c
    p_user.h
    r_bsp.c
    r_bsp.h
    r_data.c
    r_data.h
    r_defs.h
    r_draw.c
    r_draw.h
    r_fps.c
    r_fps.h
    r_main.c
    r_main.h
    r_patch.c
    r_patch.h
    r_plane.c
    r_plane.h
    r_segs.c
    r_segs.h
    r_sky.c
    r_sky.h
    r_state.h
    r_things.c
    r_things.h
    scanner.cpp
    scanner.h
    sc_man.c
    sc_man.h
    smooth.c
    smooth.h
    sounds.c
    sounds.h
    st_lib.c
    st_lib.h
    st_stuff.c
    st_stuff.h
    s_advsound.c
    s_advsound.h
    s_sound.c
    s_sound.h
    tables.c
    tables.h
    umapinfo.cpp
    umapinfo.h
    v_video.c
    v_video.h
    wadtbl.c
    wadtbl.h
    wi_stuff.c
    wi_stuff.h
    w_wad.c
    w_wad.h
    z_bmalloc.c
    z_bmalloc.h
    z_zone.c
    z_zone.h
)

set(NET_CLIENT_SRC
    d_client.c
)

if(HAVE_MMAP OR HAVE_CREATE_FILE_MAPPING)
    set(WAD_SRC w_mmap.c)
else()
    set(WAD_SRC w_memcache.c)
endif()

set(MUS2MID_SRC
    memio.c
    memio.h
    mus2mid.c
    mus2mid.h
)

set(SDLDOOM_SOURCES
    SDL/i_main.c
    SDL/i_sound.c
    SDL/i_sndfile.c
    SDL/i_sndfile.h
    SDL/i_sshot.c
    SDL/i_system.c
    SDL/i_video.c
)

set(DOOMMUSIC_SOURCES
    MUSIC/xmpplayer.c
    MUSIC/xmpplayer.h
    MUSIC/flplayer.c
    MUSIC/flplayer.h
    MUSIC/madplayer.c
    MUSIC/madplayer.h
    MUSIC/midifile.c
    MUSIC/midifile.h
    MUSIC/musicplayer.h
    MUSIC/opl.c
    MUSIC/opl.h
    MUSIC/opl3.c
    MUSIC/opl3.h
    MUSIC/oplplayer.c
    MUSIC/oplplayer.h
    MUSIC/opl_queue.c
    MUSIC/opl_queue.h
    MUSIC/portmidiplayer.c
    MUSIC/portmidiplayer.h
    MUSIC/vorbisplayer.c
    MUSIC/vorbisplayer.h
)

set(EXTRA_FILES
    r_drawcolpipeline.inl
    r_drawcolumn.inl
    r_drawflush.inl
)

set(DSDA_SOURCES
    ${COMMON_SRC}
    ${NET_CLIENT_SRC}
    ${WAD_SRC}
    ${MUS2MID_SRC}
    ${SDLDOOM_SOURCES}
    ${DOOMMUSIC_SOURCES}
    ${EXTRA_FILES}
)

function(AddGameExecutable TARGET SOURCES)
    set(SOURCES
        ${SOURCES}
        gl_clipper.c
        gl_drawinfo.c
        gl_fbo.c
        gl_intern.h
        gl_light.c
        gl_main.c
        gl_map.c
        gl_missingtexture.c
        gl_opengl.c
        gl_opengl.h
        gl_preprocess.c
        gl_progress.c
        gl_shader.c
        gl_sky.c
        gl_struct.h
        gl_texture.c
        gl_vertex.c
        gl_wipe.c
    )

    if(WIN32)
        set(SOURCES
            ${SOURCES}
            ../ICONS/icons.rc
        )
        if(MSVC)
            set(SOURCES
                ${SOURCES}
                win_opendir.c
                win_opendir.h
            )
        endif()
    endif()

    add_executable(${TARGET} WIN32 ${SOURCES})

    dsda_target_set_warnings(${TARGET})
    dsda_target_silence_deprecation(${TARGET})
    dsda_target_enable_fast_math(${TARGET})
    dsda_target_use_config_h(${TARGET})

    target_compile_features(${TARGET}
        PRIVATE
        cxx_std_11
    )

    target_include_directories(${TARGET}
        PRIVATE
        ${CMAKE_CURRENT_SOURCE_DIR}
    )

    target_link_libraries(${TARGET}
        PRIVATE
        dsda::dependencies
    )

    set_target_properties(${TARGET} PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY ${DSDA_OUTPUT_PATH}
        C_STANDARD 99
    )

    add_dependencies(${TARGET} dsda-doom-wad)
    add_custom_command(TARGET ${TARGET}
        POST_BUILD
        COMMAND ${CMAKE_COMMAND} -E echo "Copying ${WAD_DATA_PATH} to $<TARGET_FILE_DIR:dsda-doom>"
        COMMAND ${CMAKE_COMMAND} -E copy_if_different ${WAD_DATA_PATH} $<TARGET_FILE_DIR:dsda-doom>
    )

    if(MSVC)
        set_target_properties(${TARGET} PROPERTIES
            LINK_FLAGS "/MANIFEST:NO /SUBSYSTEM:CONSOLE"
        )
        add_custom_command(TARGET ${TARGET} POST_BUILD

=== debian/changelog ===
dsda-doom (0.29.4+dfsg-2) unstable; urgency=medium

  * Build-Depend on dh-sequence-bash-completion
  * Pass the canonical path to the build arch toolchain file

 -- Fabian Greffrath <fabian@debian.org>  Tue, 30 Sep 2025 15:30:50 +0200

dsda-doom (0.29.4+dfsg-1) unstable; urgency=medium

  * Bump debian/watch file to version 5
  * New upstream version 0.29.4+dfsg
  * Replace Build-Depends on libdumb1-dev with libxmp-dev for the MOD
    music backend
  * Bump Build-Depends to libfluidsynth-dev (>> 2.4.3+dfsg-4~) and
    libzip-dev (>> 1.11.3-2~) and drop the utility packages that these
    now depend on
  * Use a build arch toolchain file for the rdatawad utility, instead
    of running a native build
  * Let the upstream rules install the icon and desktop file
  * Remove reduntant RRR: no field

 -- Fabian Greffrath <fabian@debian.org>  Tue, 30 Sep 2025 08:48:22 +0200

=== debian/control ===
Source: dsda-doom
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Fabian Greffrath <fabian@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-bash-completion,
 cmake,
 libfluidsynth-dev (>> 2.4.3+dfsg-4~),
 libgl-dev,
 libglu1-mesa-dev | libglu-dev,
 libmad0-dev,
 libportmidi-dev [linux-any],
 libsdl2-dev (>= 2.0.7),
 libsdl2-image-dev,
 libsdl2-mixer-dev,
 libsdl2-net-dev,
 libvorbis-dev,
 libxmp-dev,
 libzip-dev (>> 1.11.3-2~)
Standards-Version: 4.7.2
Homepage: https://github.com/kraflab/dsda-doom
Vcs-Git: https://salsa.debian.org/games-team/dsda-doom.git
Vcs-Browser: https://salsa.debian.org/games-team/dsda-doom

Package: dsda-doom
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 freedoom | game-data-packager
Suggests:
 ffmpeg
Provides:
 boom-engine,
 doom-engine,
 heretic-engine,
 hexen-engine
Breaks:
 prboom-plus (<< 3:0.25.2-1~),
 prboom-plus-game-server (<< 3:0.25.2-1~)
Replaces:
 prboom-plus (<< 3:0.25.2-1~),
 prboom-plus-game-server (<< 3:0.25.2-1~)
Description: Doom source port with a focus on demo recording and speedrunning
 This is a fork of prboom+ with many new features, including:
 .
  * Heretic, Hexen, MBF21, and Doom-in-Hexen support
  * In-game console and scripting
  * Full controller support
  * Palette-based lightmode for opengl
  * Debugging features for testing
  * Strict mode for speedrunning
  * Various quality of life improvements
  * Advanced tools for TASing
  * Rewind
 .
 DSDA-Doom requires game data to run. Free game data is available in the
 freedoom package. Commercial game data can be packaged using
 game-data-packager. DSDA-Doom supports all flavors of Doom, including
 The Ultimate Doom, Doom 2 and Final Doom as well as Chex(R) Quest, HacX,
 Freedoom: Phase 1 and Phase 2 and FreeDM.
 .
 Additionally, DSDA-Doom supports Heretic and Hexen.

Package: prboom-plus
Architecture: all
Multi-Arch: foreign
Section: oldlibs
Depends:
 dsda-doom (>= 0.25.2-1~),
 ${misc:Depends}
Description: transitional dummy package (prboom-plus -> dsda-doom)
 This package is a dummy package to enable the prboom-plus
 to dsda-doom transition. It can be safely removed.

Package: prboom-plus-game-server
Architecture: all
Multi-Arch: foreign
Section: oldlibs
Depends:
 dsda-doom (>= 0.25.2-1~),
 ${misc:Depends}
Suggests:
 woof-doom
Description: transitional dummy package (prboom-plus-game-server -> dsda-doom)
 This package is a dummy package to enable the prboom-plus-game-server
 to dsda-doom transition. It can be safely removed.
 .
 DSDA-Doom has abandoned network gaming. A Boom-compatible Doom port with
 network gaming support compatible to the Chocolate family of ports can be
 found in the woof-doom package.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

TOOLCHAIN_FILE = $(shell readlink -f debian/toolchain)

%:
	dh $@ \
		--sourcedirectory=prboom2

override_dh_auto_configure:
	$(SHELL) /usr/share/cmake/debtoolchainfilegen $(DEB_BUILD_ARCH) > $(TOOLCHAIN_FILE)
	dh_auto_configure -- \
		-DCMAKE_INSTALL_BINDIR=games \
		-DDSDAPWADDIR=/usr/share/dsda-doom \
		-DDSDA_HOST_TOOLCHAIN=$(TOOLCHAIN_FILE)

override_dh_installchangelogs:
	dh_installchangelogs -- patch_notes/v$(basename $(DEB_VERSION_UPSTREAM))*

override_dh_gencontrol:
	dh_gencontrol -pprboom-plus             -- -v3:$(DEB_VERSION_UPSTREAM_REVISION)
	dh_gencontrol -pprboom-plus-game-server -- -v3:$(DEB_VERSION_UPSTREAM_REVISION)
	dh_gencontrol --remaining-packages

execute_after_dh_install:
	find debian/ -name 'COPYING*' -delete

=== debian/watch ===
Version: 5
Source: https://github.com/kraflab/@PACKAGE@/tags
Matching-Pattern: https://github.com/kraflab/@PACKAGE@/archive/refs/tags/v@ANY_VERSION@@ARCHIVE_EXT@
Dversion-Mangle: s/@DEB_EXT@//
Repack-Suffix: +dfsg
Compression: xz
